/* Counting Sort
   Sortarea prin Numarare - se aplica doar pentru numere naturale si nu foarte mari
   
   Complexitate:
		O(n + vmax)  = O(n)  daca vmax e de ordinul de marime al lui n
*/ 

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("counting_sort.in");
ofstream fout("counting_sort.out");

const int MaxN = 1e3,
	      MaxV = 1e5; // 100000

int a[MaxN]; // sirul care trebuie sortat
int b[MaxN]; // sirul final sortat, avand toate valorile din a[]
int n;       // nr de valori in sirul a[]
int c[MaxV]; // sir caracteristic
int vmax;    // val maxima a elementelor sirului a[]

void CitesteSir();
void SortareNumarare();
void AfiseazaSir();

int main() 
{
    CitesteSir();
    SortareNumarare();
    AfiseazaSir();
    
    return 0;
}

void SortareNumarare()
{
	// O(n)
	for (int i = 1; i <= n; ++i) 
		c[a[i]]++;                  // c[x] - numarul de valori egale cu x care apar in sir
	
	// O(vmax)
	for (int v = 1; v <= vmax; ++v) // c[v] - numarul de valori din a[] mai mici sau egale cu v
		c[v] += c[v - 1];
	
	// O(n)
	for (int i = 1; i <= n; ++i)
	{
		b[c[a[i]]] =  a[i];
		c[a[i]]--;
	}
}

void CitesteSir()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
	{
		fin >> a[i];
		vmax = max(vmax, a[i]);
	}
}

void AfiseazaSir()
{
	for (int i = 1; i <= n; ++i)
		fout << b[i] << ' ';
}






